unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Tours de Hanoi drcursifi


procedure TForm1.Button1Click(Sender: TObject);
var n,m,k,p:integer;  t,sens:byte; mouv,c:char;  H,s:string;
begin
     Screen.Cursor:=crHourGlass;
     Memo1.Clear;

     n:=SpinEdit1.Value; // nb de disques  dplacer

     m:=1; // nb de mouvements
     for k:=1 to n do m:=2*m;  // m=2^n
     dec(m); // m=2^n-1

     H:=''; // la suite des mouvements
     for k:=0 to m-1 do  // pour chaque mouvement
         begin
              t:=k mod 3; // donne le type du mouvement
              case t of
                   0:mouv:='A';
                   1:mouv:='C';
                   2:mouv:='B';
              end;

              sens:=k mod 4; // donne le sens du mouvement
              case sens of
                   0: H:=H+mouv;              // k=4p   (mouvement "majuscule")
                   1: H:=H+LowerCase(mouv);   // k=4p+1 (mouvement "minuscule")
                   2: H:=H+mouv;              // k=4p+2 (mouvement "majuscule")
                   3: begin                   // k=4p+3
                         // il faut dterminer le sens du mouvement d'indice p
                         p:=(k-3) div 4;
                         c:=H[p+1]; // dans les chanes, a commence  1...
                         if UpperCase(c)=c then H:=H+mouv // mouvement "majuscule"
                         else H:=H+LowerCase(mouv);       // mouvement "minuscule"
                      end;
              end;
         end;
     Memo1.Lines.Add('H = '+H);
     Memo1.Lines.Add(' ');

     // une petite boucle pour "dcoder" la chane H
     for k:=1 to length(H) do
         begin
              s:='Dplacer un disque de ';
              if H[k]='A' then s:=s+'1 vers 2';
              if H[k]='a' then s:=s+'2 vers 1';
              if H[k]='B' then s:=s+'2 vers 3';
              if H[k]='b' then s:=s+'3 vers 2';
              if H[k]='C' then s:=s+'3 vers 1';
              if H[k]='c' then s:=s+'1 vers 3';
              Memo1.Lines.Add(s);
         end;
     Screen.Cursor:=crDefault;
end;

end.
